'use strict';

// tooling
var postcss = require('postcss');

// plugins by name
var plugins = {
	sequence: require('postcss-sequence'),
	negativePadding: require('postcss-negative-padding'),
	layouts: require('postcss-layouts'),
	exactWidth: require('postcss-exact-width'),
	gutters: require('postcss-gutters')
};

// plugin
var index = postcss.plugin('postcss-fiber', function (rawopts) {
	// options
	var opts = Object.assign({}, rawopts);

	// cached processor
	var processor = postcss();

	// for each plugin
	Object.keys(plugins).forEach(function (name) {
		// plugin options by name
		var pluginOpts = Object.assign({
			disable: opts[name] === false
		}, opts[name]);

		// if the plugin is not disabled
		if (!pluginOpts.disable) {
			// use the plugin
			processor.use(plugins[name](pluginOpts));
		}
	});

	return processor;
});

module.exports = index;
